Last Comment Bug 380236 - (js1.8) JS1.8 tracking bug
(js1.8)
: JS1.8 tracking bug
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: Trunk
: All All
: P3 normal with 1 vote (vote)
: mozilla1.9
Assigned To: Brendan Eich [:brendan]
:
:
Mentors:
http://wiki.mozilla.org/JavaScript:Ho...
Depends on: 349326 363040 363891 366941 376957 genexp 380469 381031 expclo 381372 382182 382981 383674 384642 384758 384991 402386 404734 408871 408957 409252 410571 416628 416636 doc-js1.8 532652
Blocks: js1.8src
  Show dependency treegraph
 
Reported: 2007-05-09 18:46 PDT by Brendan Eich [:brendan]
Modified: 2009-12-03 07:26 PST (History)
36 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Brendan Eich [:brendan] 2007-05-09 18:46:37 PDT
JS1.8, to ship as part of Gecko 1.9, will be a smaller change from JS1.7 than 1.7 was from 1.6. But there are a few things we want to fix in 1.7 to track ES4/JS2, and a few more things from ES4 to implement and field-test:

- generator expressions
- JSON encoder and decoder
- slice syntax
- more and better array extras (see bug 363040)
- generalized destructuring for-in (bug 366941)

Missing dependency bugs coming soon.

/be
Comment 1 Brendan Eich [:brendan] 2007-05-09 18:49:22 PDT
Also:

- generator.close() automation only for a generator started by a for-in construct

This will simplify the GC, but require JSOP_ENDITER emulation by JSOP_SETSP so that close is automated when exiting a for-in due to an exception.

/be
Comment 2 Brendan Eich [:brendan] 2007-05-09 18:50:03 PDT
mrbkap, please propose bugs that we didn't fix for js1.7 (that one where let bindings turn into var bindings at top level, e.g.).

/be
Comment 3 Robert Sayre 2007-05-09 18:56:54 PDT
how about bug 238324?
Comment 4 Brendan Eich [:brendan] 2007-05-09 19:04:02 PDT
(In reply to comment #3)
> how about bug 238324?

That looks at a glance to be entirely outside of the core language and engine -- is it? Core language features such as packages should wait for JS2 on Tamarin (ActionMonkey), which will start development very soon but take longer than JS1.8. JS1.8 needs to be wrapped up pretty quickly.

/be
Comment 5 :Gavin Sharp [email: gavin@gavinsharp.com] 2007-05-09 19:49:57 PDT
(In reply to comment #0)
> - JSON encoder and decoder

That's bug 340987.
Comment 6 Igor Bukanov 2007-05-10 01:15:02 PDT
(In reply to comment #1)
> Also:
> 
> - generator.close() automation only for a generator started by a for-in
> construct

Finally a sensible thing to do that would remove all that crazy stuff about close phase and its scheduling.

> 
> This will simplify the GC, but require JSOP_ENDITER emulation by JSOP_SETSP so
> that close is automated when exiting a for-in due to an exception.

This is bug 349326. I will try to implement it based on bug 379758 comment 1 during this week.
Comment 7 Mike Shaver (:shaver -- probably not reading bugmail closely) 2007-05-10 05:32:08 PDT
Related (I think): can/should we make JS1.8 the default for XUL-loaded JS in Gecko 1.9?  We didn't in 1.8.1 for good compatibility reasons, but it makes for a lot of poking around by extension and app authors to get the right versioning parameters, and I think we'd do better by them in 1.9 to make the switch.
Comment 8 Brendan Eich [:brendan] 2007-05-10 23:08:19 PDT
(In reply to comment #7)
> Related (I think): can/should we make JS1.8 the default for XUL-loaded JS in
> Gecko 1.9?  We didn't in 1.8.1 for good compatibility reasons, but it makes for
> a lot of poking around by extension and app authors to get the right versioning
> parameters, and I think we'd do better by them in 1.9 to make the switch.

Please file that bug and make it block this one?

/be
Comment 9 Brendan Eich [:brendan] 2007-05-10 23:12:48 PDT
(In reply to comment #6)
> (In reply to comment #1)
> > Also:
> > 
> > - generator.close() automation only for a generator started by a for-in
> > construct
> 
> Finally a sensible thing to do that would remove all that crazy stuff about
> close phase and its scheduling.

Yes, JS1.7 followed Python too far there. Sorry about that.

> > This will simplify the GC, but require JSOP_ENDITER emulation by JSOP_SETSP so
> > that close is automated when exiting a for-in due to an exception.
> 
> This is bug 349326. I will try to implement it based on bug 379758 comment 1
> during this week.

Do you want to rip out the close phase in the same bug?

/be
Comment 10 Igor Bukanov 2007-05-10 23:56:14 PDT
(In reply to comment #9)
> > This is bug 349326. I will try to implement it based on bug 379758 comment 1
> > during this week.
> 
> Do you want to rip out the close phase in the same bug?

No. I prefer not to mix the patches implementing different things.
Comment 11 Brendan Eich [:brendan] 2007-05-11 08:50:08 PDT
(In reply to comment #10)
> No. I prefer not to mix the patches implementing different things.

Sounds good -- would you please file that bug and make it block this one? Thanks,

/be
Comment 12 Igor Bukanov 2007-05-11 17:37:43 PDT
(In reply to comment #11)
> 
> would you please file that bug and make it block this one?

See bug 380469.
Comment 13 Nickolay_Ponomarev 2007-05-17 05:26:30 PDT
(In reply to comment #7)
> Related (I think): can/should we make JS1.8 the default for XUL-loaded JS in
> Gecko 1.9? 
Filed bug 381031.
Comment 14 Brendan Eich [:brendan] 2007-05-29 22:21:23 PDT
We want to ban indirect eval, except for w.eval where w is a window object. Is there a bug on file already? I'm not sure we can pull this off before Mozilla 2, but it's worth considering.

/be
Comment 15 Jeff Walden [:Waldo] (remove +bmo to email) 2007-05-30 15:34:10 PDT
See bug 382509.
Comment 16 Brendan Eich [:brendan] 2008-03-04 17:42:51 PST
This bug should be closed soon. A doc-js1.8 bug may still be needed. Opinions?

/be
Comment 17 John Resig 2008-03-04 22:32:20 PST
I'll be tackling docs, I've already made some good headway:
http://developer.mozilla.org/en/docs/New_in_JavaScript_1.8

I'll go back through the recently-closed tickets and make sure everything lands in there. The tracking bug for doc-js1.8 is bug 421027.
Comment 18 Brendan Eich [:brendan] 2008-03-18 02:48:34 PDT
Waldo, you going to get to bug 416636 soon?

/be
Comment 19 Dirkjan Ochtman (:djc) 2008-06-11 23:32:58 PDT
Any updates on this? It would be nice to have a current SpiderMonkey release, with all the performance improvements that are in Fx3.
Comment 20 Jason Orendorff [:jorendorff] 2008-06-19 09:29:56 PDT
Dirkjan, for the source release, see bug 428420, which has quite a few blocking bugs, including some ugly crashes (that don't affect Firefox).
Comment 21 Bob Clary [:bc:] 2008-06-23 05:15:27 PDT
I moved the dependencies from bug 428420 to here.
Comment 22 Bob Clary [:bc:] 2008-06-23 12:00:55 PDT
reverting changes made in comment 21 due to bug 428420 comment 5.
Comment 23 Brendan Eich [:brendan] 2009-04-06 11:20:38 PDT
1.8 is out. This bug should probably be closed and any depends-on bugs moved to a new tracker.

/be
Comment 24 Brendan Eich [:brendan] 2009-05-08 14:24:15 PDT
I'm going to resolve this -- I think bug 421027 is resolved too, just not yet marked resolved.

/be

Note You need to log in before you can comment on or make changes to this bug.